//needed libs
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
//tray object
#include "eggtrayicon.h"
//xchat plugin core
#include "xchat-plugin.h"
//notify icons
#include "xchatpng.h"
#include "xchatredpng.h"
#include "xchatbluepng.h"
#include "xchatdccxpm.h"
#include "xchatdiscxpm.h"
#include "xchatinvxpm.h"
#include "xchatnotoutxpm.h"
#include "xchatnotinxpm.h"
//tray menu icons
#include "xchatquitpng.h"
#include "xchatbrowser.h"
#include "xchatplayer.h"
#include "xchatemail.h"
#include "xchatmaxxpm.h"
#include "xchatminxpm.h"
#include "xchatsettings.h"
#include "xchatgoaway.h"
#include "xchatbackaway.h"

//xchat plugin var
static xchat_plugin *ph;
static xchat_context *flash_ctx = NULL;
static xchat_context *focus_ctx;
//notify icon
static GdkPixbuf *pix_xchat;
static GdkPixbuf *pix_xchat_red;
static GdkPixbuf *pix_xchat_blue;
static GdkPixbuf *pix_xchat_dcc;
static GdkPixbuf *pix_xchat_disc;
static GdkPixbuf *pix_xchat_inv;
static GdkPixbuf *pix_xchat_notin;
static GdkPixbuf *pix_xchat_notout;
static GdkPixbuf *buffer9;
//set flashing icon
static GdkPixbuf *icontype;
//core var
static GHashTable *servers_names = NULL;
static GtkWidget *eventbox;
static gint flash_id = 0;
static EggTrayIcon *tray_icon;
static GtkWidget *tray_icon_image;
static GtkWidget *status_menu;
static GtkWidget *global_away_button;
static GtkWidget *checkbutton,*checkbutton2,*checkbutton3;
static GtkWidget *item,*browser_text,*email_text,*player_text;
static GtkWidget *away1,*away2,*away3,*away_nick_box,*away_nick_pass_box,*away_text;
static GtkWidget *filew;
GtkWidget **app2set;
static GtkTooltips *tray_icon_tooltip;
//settings items array
static char ppath[150];
static char epath[150];
static char bpath[150];
static char away_msg1[150];
static char away_msg2[150];
static char away_msg3[150];
static char away_nick[150];
static char away_pass[150];
static int check;
//settings items
const char* ppath1;
const char* epath1;
const char* bpath1;
const char* amsg1;
const char* amsg2;
const char* amsg3;
const char* message;
const char* awaynick;
const char* awaypass;
const char* actual_nick;
const char* oldnick;
char nick[150];
//control var
static gboolean on_start=TRUE;
static gboolean go_change=TRUE;
static gboolean go_identify=TRUE;
static gboolean edit;
static gboolean global_away=FALSE;
static gboolean global_away_temp=FALSE;
static gboolean on_away=FALSE;
static gint status = 1;
static gulong s1,s2;
static gint onExit = 1;
static char* version;
static gboolean control=TRUE;
//prototypes
static gboolean tray_clicked (GtkWidget *event_box, GdkEventButton *event, gpointer data);
static gboolean tray_menu (GtkWidget *event_box, GdkEventButton *event, gpointer data);
static void away_use_yes(GtkWidget *button, void *data);
static void away_use_not(GtkWidget *button, void *data);
static void away_ident_yes(GtkWidget *button, void *data);
static void away_ident_not(GtkWidget *button, void *data);
static void tray_init(void);
static void tray_init_gui(void);
static void flash_stop();
static void set_tray();


//START IMPLEMENTATION

//WARNINGS

//alert if file settings has not been created or not readable
void show_warning() {

	GtkWidget *window;
	GtkWidget *button,*titlebox,*box1,*box2;
	GtkWidget *label;

	xchat_printf(ph,"SysTray Integration Plugin not setted properly, please set it now");

	//create box and window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "Settings Missing");
	gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	//first container box
	box1 = gtk_vbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (window), box1);
	gtk_widget_show (box1);

	//other containers
	titlebox = gtk_hbox_new (FALSE, 0);
    	gtk_box_pack_start (GTK_BOX (box1), titlebox, FALSE, FALSE, 0);
   	gtk_widget_show (titlebox);

	box2 = gtk_hbox_new (FALSE, 10);
    	gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, FALSE, 0);
   	gtk_widget_show (box2);

	label = gtk_label_new ("SysTray Integration Plugin Settings\n\nare corrupted, not setted properly or missing.\n\nPlease set it now to use Plugin Features\n\n");
  	gtk_box_pack_start (GTK_BOX (titlebox), label, FALSE, FALSE, 0);
  	gtk_widget_show (label);

	//set now
	button = gtk_button_new_with_label ("Set it now");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_tray), NULL);
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 40);
    	gtk_widget_show (button);

	//do not set
	button = gtk_button_new_with_label ("I'll set it later");
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 40);
	gtk_widget_show (button);
	gtk_widget_show (box1);
	gtk_widget_show (box2);
	gtk_widget_show (window);
}

//2 sec time to fix seg. fault
void unload_plugin(){

	xchat_command(ph, "timer 2 unload systray");

}

//if version is old
void version_warning() {

	GtkWidget *window;
	GtkWidget *button,*titlebox,*box1,*box2;
	GtkWidget *label;


	xchat_print (ph, "Your XChat version is too old!\n");
	xchat_print (ph, "You will not be able to use: Minimize, Restore, Exit, Focus feature.\n");
	xchat_print (ph, "Please update it http://www.xchat.org\n");

	//create box and window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "Version Problem");
	gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	//first container box
	box1 = gtk_vbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (window), box1);
	gtk_widget_show (box1);

	//other containers
	titlebox = gtk_hbox_new (FALSE, 0);
    	gtk_box_pack_start (GTK_BOX (box1), titlebox, FALSE, FALSE, 0);
   	gtk_widget_show (titlebox);

	box2 = gtk_hbox_new (FALSE, 10);
    	gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, FALSE, 0);
   	gtk_widget_show (box2);

	label = gtk_label_new ("You have an old XChat version.\n\nThis means you will not be able to use some features like:\n  1) Restore\n  2) Minimize\n  3) Exit\n  4) Full Focus feature\n\n However you can use SysTray Plugin without them\n or you can choose to unload plugin.\n\n");
  	gtk_box_pack_start (GTK_BOX (titlebox), label, FALSE, FALSE, 0);
  	gtk_widget_show (label);

	//use
	button = gtk_button_new_with_label ("Use it");
   	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 60);
    	gtk_widget_show (button);

	//unload
	button = gtk_button_new_with_label ("Unload");
	g_signal_connect (G_OBJECT (button), "clicked",G_CALLBACK (unload_plugin),0);
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 40);
	gtk_widget_show (button);
	gtk_widget_show (box1);
	gtk_widget_show (box2);
	gtk_widget_show (window);
}

//SAVING AND READING SETTINGS

//save function
void write2file(){

	FILE *systray;
	char path[150];
	sprintf(path,"%s/systray.conf", xchat_get_info(ph, "xchatdir"));
	systray = fopen(path,"w");
	if (systray != NULL) {
		fprintf(systray,"%s\n",bpath1);
		fprintf(systray,"%s\n",epath1);
		fprintf(systray,"%s\n",ppath1);
		fprintf(systray,"%s\n",amsg1);
		fprintf(systray,"%s\n",amsg2);
		fprintf(systray,"%s\n",amsg3);
		fprintf(systray,"%s\n",awaynick);
		fprintf(systray,"%s\n",awaypass);
		if (go_change== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (go_identify== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		xchat_printf(ph,"Successfully saved settings to file.\n");
		fclose(systray);
	} else {
		xchat_printf(ph,"Error writing to file %s.\n", path);
	}
}
//get apps path & settings
void get_info ()  {
	FILE *systray;
	char path[150];
	int len;
	sprintf(path,"%s/systray.conf", xchat_get_info(ph, "xchatdir"));
	systray = fopen(path,"r");
	if (systray != NULL) {
		//cut off the "\n" value
		fgets(bpath,150,systray);
		len=strlen(bpath); if ( len && bpath[len-1] == '\n' ) bpath[len-1] = 0;
		fgets(epath,150,systray);
		len=strlen(epath); if ( len && epath[len-1] == '\n' ) epath[len-1] = 0;
		fgets(ppath,150,systray);
		len=strlen(ppath); if ( len && ppath[len-1] == '\n' ) ppath[len-1] = 0;
		fgets(away_msg1,150,systray);
		len=strlen(away_msg1); if ( len && away_msg1[len-1] == '\n' ) away_msg1[len-1] = 0;
		fgets(away_msg2,150,systray);
		len=strlen(away_msg2); if ( len && away_msg2[len-1] == '\n' ) away_msg2[len-1] = 0;
		fgets(away_msg3,150,systray);
		len=strlen(away_msg3); if ( len && away_msg3[len-1] == '\n' ) away_msg3[len-1] = 0;
		fgets(away_nick,150,systray);
		len=strlen(away_nick); if ( len && away_nick[len-1] == '\n' ) away_nick[len-1] = 0;
		fgets(away_pass,150,systray);
		len=strlen(away_pass); if ( len && away_pass[len-1] == '\n' ) away_pass[len-1] = 0;
		fscanf(systray,"%d",&check);
		if ( check== 1 ) go_change=TRUE;
		else go_change=FALSE;
		fscanf(systray,"%d",&check);
		if ( check== 1 ) go_identify=TRUE;
		else go_identify=FALSE;
		if (control) xchat_printf(ph,"Successfully loaded settings from file.\n");
		fclose(systray);
	}
	else {
		xchat_printf(ph,"Error opening file %s.\n", path);
		show_warning();
	}

}

// calls saving function and updates variables
void save(){

	xchat_printf(ph, "These are your selected application paths & settings:\n");
	bpath1= gtk_entry_get_text( GTK_ENTRY(browser_text) );
	xchat_printf(ph, "Browser: %s",bpath1);
	epath1= gtk_entry_get_text( GTK_ENTRY(email_text) );
	xchat_printf(ph, "Email Client: %s",epath1);
	ppath1= gtk_entry_get_text( GTK_ENTRY(player_text) );
	xchat_printf(ph, "Multimedia Player: %s",ppath1);
	amsg1= gtk_entry_get_text( GTK_ENTRY(away1) );
	xchat_printf(ph, "Your first favourite away message: %s",amsg1);
	amsg2= gtk_entry_get_text( GTK_ENTRY(away2) );
	xchat_printf(ph, "Your second favourite away message: %s",amsg2);
	amsg3= gtk_entry_get_text( GTK_ENTRY(away3) );
	xchat_printf(ph, "Your third favourite away message: %s",amsg3);
	awaynick=gtk_entry_get_text( GTK_ENTRY(away_nick_box) );
	awaypass=gtk_entry_get_text( GTK_ENTRY(away_nick_pass_box) );
	if (go_change==TRUE) {
		xchat_printf(ph, "While in away, you want to change your nick in: %s",awaynick);
		if ( go_identify == TRUE ) {

			xchat_printf(ph, "Your away nick password is: %s",awaypass);
		}
		else xchat_printf(ph, "Your away nick doesn't need to be identified.");
	}
	else xchat_printf(ph, "While in away, you don't want to change your nick.");
	xchat_print(ph, "\nIf you want to change settings, please select Settings again.");
	write2file();
	get_info();
}

//CHOOSE APP PATH

//file selected
static void ok_click( GtkWidget *w, GtkFileSelection *fs )
{
    gtk_entry_set_text(GTK_ENTRY(*app2set), gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));

    gtk_widget_destroy(filew);
}

//file selection gui
void app_select()
{

    filew = gtk_file_selection_new ("Select the right path");

    g_signal_connect (G_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
                      "clicked", G_CALLBACK (ok_click), (gpointer) filew);

    g_signal_connect_swapped (G_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
                              "clicked", G_CALLBACK (gtk_widget_destroy),
                              G_OBJECT (filew));

    gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew),
                                     "");
    gtk_widget_show (filew);

}

//browser popup gui
void browser_select() {

    app2set=&browser_text;
	app_select();

}

//email client popup gui
void email_select() {

    app2set=&email_text;
	app_select();

}

//multimedia player popup gui
void player_select() {

	app2set=&player_text;
	app_select();

}

// SETTINGS GUI


//delete setting window and reload real values.
static void set_tray_delete() {

	control=FALSE;
	get_info();
	control=TRUE;
}

//settings gui
static void set_tray(){

	GtkWidget *window;
	GtkWidget *table;
	GtkWidget *button,*box1,*box2,*box3;
	GtkWidget *label;
	GSList *group;

	//create box and window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
	gtk_window_set_title (GTK_WINDOW (window), "SysTray Settings");
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	table=gtk_table_new(13,3,FALSE);
	gtk_table_set_col_spacings(GTK_TABLE(table), 40 );
	gtk_table_set_row_spacings(GTK_TABLE(table), 12 );
	gtk_container_add (GTK_CONTAINER (window), table);

	box1 = gtk_hbox_new (FALSE, 40);
	box2 = gtk_hbox_new (FALSE, 40);
	box3 = gtk_hbox_new (FALSE, 60);

	label = gtk_label_new ("SysTray Settings. Select your favorite apps and settings");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,2,0,1);
  	gtk_widget_show (label);

	//1 button
	label = gtk_label_new ("Select your favorite browser");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,1,2);
	gtk_widget_show (label);

	browser_text = gtk_entry_new ();
	gtk_table_attach_defaults(GTK_TABLE(table),browser_text,1,2,1,2);
	gtk_entry_set_max_length(GTK_ENTRY(browser_text), 150);
	gtk_entry_set_text(GTK_ENTRY(browser_text), bpath);
    	gtk_widget_show (browser_text);

	button = gtk_button_new_with_label ("Select");
	gtk_table_attach_defaults(GTK_TABLE(table),button,2,3,1,2);
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (browser_select), NULL);
    	gtk_widget_show (button);

	//2 button
    	label = gtk_label_new ("Select your favorite email client");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,2,3);
 	gtk_widget_show (label);

	email_text = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(email_text), 150);
	gtk_entry_set_text(GTK_ENTRY(email_text), epath);
	gtk_table_attach_defaults(GTK_TABLE(table),email_text,1,2,2,3);
 	gtk_widget_show (email_text);

	button = gtk_button_new_with_label ("Select");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (email_select), NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),button,2,3,2,3);
    	gtk_widget_show (button);

	//3 button
	label = gtk_label_new ("Select your favorite multimedia player	");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,3,4);
    	gtk_widget_show (label);

	player_text = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(player_text), 150);
	gtk_entry_set_text(GTK_ENTRY(player_text), ppath);
	gtk_table_attach_defaults(GTK_TABLE(table),player_text,1,2,3,4);
    	gtk_widget_show (player_text);

	button = gtk_button_new_with_label ("Select");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (player_select), NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),button,2,3,3,4);
    	gtk_widget_show (button);

	//away msg n1
	label = gtk_label_new ("Write your first favourite away message	");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,4,5);
    	gtk_widget_show (label);

	away1 = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away1), 150);
	gtk_entry_set_text(GTK_ENTRY(away1), away_msg1);
	gtk_table_attach_defaults(GTK_TABLE(table),away1,1,3,4,5);
    	gtk_widget_show (away1);

	//away msg n2
	label = gtk_label_new ("Write your second favourite away message");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,5,6);
    	gtk_widget_show (label);

	away2 = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away2), 150);
	gtk_entry_set_text(GTK_ENTRY(away2), away_msg2);
	gtk_table_attach_defaults(GTK_TABLE(table),away2,1,3,5,6);
    	gtk_widget_show (away2);

	//away msg n3
	label = gtk_label_new ("Write your third favourite away message	");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,6,7);
    	gtk_widget_show (label);

	away3 = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away3), 150);
	gtk_entry_set_text(GTK_ENTRY(away3), away_msg3);
	gtk_table_attach_defaults(GTK_TABLE(table),away3,1,3,6,7);
    	gtk_widget_show (away3);

	label = gtk_label_new ("Change Nick while away?");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,7,8);
    	gtk_widget_show (label);

	gtk_table_attach_defaults(GTK_TABLE(table),box1,1,2,7,8);

	checkbutton = gtk_radio_button_new_with_label (NULL, "yes");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
   	g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (away_use_yes),G_OBJECT (checkbutton));
	gtk_box_pack_start (GTK_BOX (box1), checkbutton, FALSE, FALSE, 15);
 	gtk_widget_show (checkbutton);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton));
  	checkbutton = gtk_radio_button_new_with_label (group, "no");
	if ( go_change == FALSE) gtk_button_clicked (GTK_BUTTON(checkbutton));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
 	g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (away_use_not),G_OBJECT (checkbutton));
  	gtk_box_pack_start (GTK_BOX (box1), checkbutton, FALSE, FALSE, 15);
  	gtk_widget_show (checkbutton);
	gtk_widget_show (box1);

	label = gtk_label_new ("Enter your away nickname");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,8,9);
    	gtk_widget_show (label);

	away_nick_box = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away_nick_box), 150);
	gtk_entry_set_text(GTK_ENTRY(away_nick_box), away_nick);
	gtk_table_attach_defaults(GTK_TABLE(table),away_nick_box,1,3,8,9);
 	gtk_widget_show (away_nick_box);

	label = gtk_label_new ("Away nick needs to be identified?");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,9,10);
    	gtk_widget_show (label);

	gtk_table_attach_defaults(GTK_TABLE(table),box2,1,3,9,10);

	checkbutton2 = gtk_radio_button_new_with_label (NULL, "yes");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton2), FALSE);
   	g_signal_connect (G_OBJECT (checkbutton2), "toggled", G_CALLBACK (away_ident_yes),G_OBJECT (checkbutton2));
   	gtk_box_pack_start (GTK_BOX (box2), checkbutton2, FALSE, FALSE, 15);
 	gtk_widget_show (checkbutton2);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton2));
  	checkbutton3 = gtk_radio_button_new_with_label (group, "no");
	if ( go_identify == FALSE) gtk_button_clicked (GTK_BUTTON(checkbutton3));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton3), FALSE);
 	g_signal_connect (G_OBJECT (checkbutton3), "toggled", G_CALLBACK (away_ident_not),G_OBJECT (checkbutton3));
  	gtk_box_pack_start (GTK_BOX (box2), checkbutton3, FALSE, FALSE, 15);
  	gtk_widget_show (checkbutton3);
	gtk_widget_show(box2);

	label = gtk_label_new ("Enter your away nickname password");
 	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,10,11);
    	gtk_widget_show (label);

	away_nick_pass_box = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away_nick_pass_box), 150);
	gtk_entry_set_visibility(GTK_ENTRY(away_nick_pass_box), FALSE);
	gtk_entry_set_text(GTK_ENTRY(away_nick_pass_box), away_pass);
	gtk_table_attach_defaults(GTK_TABLE(table),away_nick_pass_box,1,3,10,11);
 	gtk_widget_show (away_nick_pass_box);

	//4-5 button
	gtk_table_attach_defaults(GTK_TABLE(table),box3,0,3,12,13);

	button = gtk_button_new_with_label ("Apply");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (save), NULL);
    	gtk_box_pack_start (GTK_BOX (box3), button, FALSE, FALSE, 120);
    	gtk_widget_show (button);

	button = gtk_button_new_with_label ("Close");
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_tray_delete), NULL);
	g_signal_connect (G_OBJECT (window), "delete_event", G_CALLBACK (set_tray_delete), G_OBJECT (window));
	g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (set_tray_delete), G_OBJECT (window));
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    	gtk_box_pack_start (GTK_BOX (box3), button, FALSE, FALSE, 47);
    	gtk_widget_show (button);
	gtk_widget_show (box3);

	if ( go_change == FALSE) away_use_not(checkbutton, NULL);
	if ( go_identify == FALSE) away_ident_not(checkbutton3, NULL);
	gtk_widget_show(table);
 	gtk_widget_show (window);

}

//AWAY SYSTEM

//get the select away msg
void get_label(GtkWidget *button, void *data){

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) ) {
		gtk_entry_set_text(GTK_ENTRY(away_text), gtk_button_get_label(GTK_BUTTON(button)));
	}
}

//if you choose to change nick while away
static void away_use_yes(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) ) {
		go_change=TRUE;
		gtk_editable_set_editable(GTK_EDITABLE(away_nick_box), TRUE);
		gtk_entry_set_text(GTK_ENTRY(away_nick_box), "");
		edit=TRUE;
	}

}

//if you do not choose to change nick while away
static void away_use_not(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) ) {
			go_change=FALSE;
			go_identify=FALSE;
			gtk_entry_set_text(GTK_ENTRY(away_nick_box), "None");
			gtk_editable_set_editable(GTK_EDITABLE(away_nick_box), FALSE);
			gtk_entry_set_text(GTK_ENTRY(away_nick_pass_box), "None");
			gtk_editable_set_editable(GTK_EDITABLE(away_nick_pass_box), FALSE);
			gtk_button_clicked (GTK_BUTTON(checkbutton3));
			edit=FALSE;
	}
}

//if you choose to identify away nick
static void away_ident_yes(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) &&	 edit ) {
		go_identify=TRUE;
		gtk_editable_set_editable(GTK_EDITABLE(away_nick_pass_box), TRUE);
		gtk_entry_set_text(GTK_ENTRY(away_nick_pass_box), "");
	}
	if (!edit) gtk_button_clicked (GTK_BUTTON(checkbutton3));
}

//if you do not choose to identify away nick
static void away_ident_not(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) ) {
		go_identify=FALSE;
		gtk_entry_set_text(GTK_ENTRY(away_nick_pass_box), "None");
		gtk_editable_set_editable(GTK_EDITABLE(away_nick_pass_box), FALSE);
	}
}

//go away
void go_away(){

	char command[150]="away ";
	char msg[150];
	xchat_list *list;
	char command1[150]="nick ";
	char command2[150]="ns identify ";
	xchat_context *temp_focus;


	temp_focus=xchat_find_context(ph,0,0);
	on_away=TRUE;
	strcpy(msg,message);
	strcat(command,msg);
	strcat(command1,away_nick);
	strcat(command2,away_pass);

    	if(global_away) {
		list = xchat_list_get(ph, "channels");
		if(list){
      			while(xchat_list_next(ph, list))  {
				if ( xchat_list_int(ph, list, "type") ==1 ) {
					xchat_set_context(ph, (xchat_context *)xchat_list_str(ph, list, "context"));
					xchat_command( ph, "gui focus" );
					if ( g_hash_table_lookup(servers_names,xchat_get_info(ph, "server"))==NULL) {
						g_hash_table_insert(servers_names,
									(char*)xchat_get_info(ph, "server"),
									g_strdup((char*)xchat_get_info(ph, "nick")));
						xchat_command(ph, command);
						gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), buffer9);
						if (go_change) {
							xchat_command(ph, command1);
							if (go_identify) {
								xchat_command(ph, command2);
							}
						}
					}
					else xchat_printf(ph, "You are already marked away on %s server", xchat_get_info(ph, "server"));
      				}
			}
		}
	xchat_list_free(ph, list);
	}
	else { if ( g_hash_table_lookup(servers_names,xchat_get_info(ph, "server"))==NULL ) {
			g_hash_table_insert(servers_names,
						(char*)(xchat_get_info(ph, "server")),
						g_strdup(xchat_get_info(ph, "nick")));
			xchat_command(ph, command);
			if (go_change) {
				xchat_command(ph, command1);
				if (go_identify) {
					xchat_command(ph, command2);
				}
			}
		}
		else xchat_printf(ph, "You are already marked away on %s server", xchat_get_info(ph, "server"));
	}
	xchat_set_context(ph,temp_focus);
	xchat_command( ph, "gui focus" );
}

//set the away msg
void set_away_msg() {

	message=gtk_entry_get_text(GTK_ENTRY(away_text));
	go_away();
}


void restore_away() {

	global_away=global_away_temp;

}

void set_global() {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(global_away_button)))
	global_away=TRUE;
	else global_away=FALSE;

}

//choose the away message
void select_away() {

    GtkWidget *window = NULL;
    GtkWidget *box1;
    GtkWidget *box2,*box3,*box4;
    GtkWidget *button;
    GSList *group;

    global_away_temp=global_away;

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (window), "Select Your Favourite Away Message");
    gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
    gtk_container_set_border_width (GTK_CONTAINER (window), 0);

    box1 = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (window), box1);
    gtk_widget_show (box1);

    box2 = gtk_vbox_new (FALSE, 10);
    gtk_container_set_border_width (GTK_CONTAINER (box2), 10);
    gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, FALSE, 0);
    gtk_widget_show (box2);

    box4 = gtk_hbox_new (FALSE, 10);
    gtk_container_set_border_width (GTK_CONTAINER (box4), 10);
    gtk_box_pack_start (GTK_BOX (box1), box4, FALSE, FALSE, 0);
    gtk_widget_show (box4);

    box3 = gtk_hbox_new (FALSE, 10);
    gtk_container_set_border_width (GTK_CONTAINER (box3), 10);
    gtk_box_pack_start (GTK_BOX (box1), box3, FALSE, FALSE, 0);
    gtk_widget_show (box3);

    checkbutton = gtk_radio_button_new_with_label (NULL, away_msg1);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
    g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (get_label),G_OBJECT (checkbutton));
    gtk_box_pack_start (GTK_BOX (box2), checkbutton, FALSE, FALSE, 0);
    gtk_widget_show (checkbutton);

    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton));
    checkbutton = gtk_radio_button_new_with_label (group, away_msg2);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
    g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (get_label),G_OBJECT (checkbutton));
    gtk_box_pack_start (GTK_BOX (box2), checkbutton, FALSE, FALSE, 0);
    gtk_widget_show (checkbutton);

    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton));
    checkbutton = gtk_radio_button_new_with_label (group, away_msg3);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
    g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (get_label),G_OBJECT (checkbutton));
    gtk_box_pack_start (GTK_BOX (box2), checkbutton, FALSE, FALSE, 0);
    gtk_widget_show (checkbutton);

    global_away_button =  gtk_check_button_new_with_label ("Apply to all servers (global away)");
    gtk_box_pack_start (GTK_BOX (box2), global_away_button, FALSE, FALSE, 0);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (global_away_button), TRUE);
    g_signal_connect (G_OBJECT (global_away_button), "toggled", G_CALLBACK (set_global),NULL);
    global_away=TRUE;
    gtk_widget_show (global_away_button);

    away_text = gtk_entry_new ();
    gtk_entry_set_max_length(GTK_ENTRY(away_text), 150);
    gtk_entry_set_text(GTK_ENTRY(away_text), away_msg1);
    gtk_entry_set_width_chars(GTK_ENTRY(away_text),50);
    gtk_box_pack_start (GTK_BOX (box4), away_text, FALSE, FALSE, 0);
    gtk_widget_show (away_text);

    button = gtk_button_new_with_label ("Ok");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_away_msg), NULL);
    g_signal_connect_swapped (G_OBJECT (button), "clicked", G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    gtk_box_pack_start (GTK_BOX (box3), button, FALSE, FALSE, 50);
    gtk_widget_show (button);

    button = gtk_button_new_with_label ("Cancel");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (restore_away), NULL);
    g_signal_connect_swapped (G_OBJECT (button), "clicked", G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    gtk_box_pack_start (GTK_BOX (box3), button, FALSE, FALSE, 40);

    gtk_widget_show (button);
    gtk_widget_show (window);


}

//come back from away
void back_away(){

	xchat_list *list;
	char command[150];
	char temp[6]="nick ";
	char buffer[150];
	xchat_context *temp_focus;
	temp_focus=xchat_find_context(ph,0,0);

	if (global_away) {
		list = xchat_list_get(ph, "channels");
		if(list) {
      			while(xchat_list_next(ph, list))  {
				if ( xchat_list_int(ph, list, "type") ==1 ) {
					xchat_set_context(ph, (xchat_context *)xchat_list_str(ph, list, "context"));
					xchat_command( ph, "gui focus" );
					if ( g_hash_table_lookup(servers_names,xchat_get_info(ph, "server"))!=NULL ) {
						oldnick=g_hash_table_lookup (servers_names,xchat_get_info(ph, "server"));
						xchat_command( ph, "away" );
						strcpy(buffer,oldnick);
						strcpy(command,temp);
						strcat(command,buffer);
						xchat_command(ph, command);
						g_hash_table_remove(servers_names,xchat_get_info(ph, "server"));
						on_away=FALSE;
					}
				}
			}
			gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), pix_xchat);
			xchat_list_free(ph, list);
		}
	}
	else { if ( g_hash_table_lookup(servers_names,xchat_get_info(ph, "server"))!=NULL ) {
					oldnick=g_hash_table_lookup (servers_names,xchat_get_info(ph, "server"));
					xchat_command( ph, "away" );
					strcpy(buffer,oldnick);
					strcpy(command,temp);
					strcat(command,buffer);
					xchat_command(ph, command);
					g_hash_table_remove(servers_names,xchat_get_info(ph, "server"));
					on_away=FALSE;
				}
		else xchat_printf(ph, "You are not marked as being away on %s server!",xchat_get_info(ph, "server"));
	}
	xchat_set_context(ph,temp_focus);
	xchat_command( ph, "gui focus" );

}

//MENU CREATION AND COMMANDS


//launch browser
void launch_browser() {

	char command[156]="exec ";
	strcat(command, bpath);
	xchat_command( ph, command );

}
//launch email
void launch_email() {

	char command[156]="exec ";
	strcat(command, epath);
	xchat_command( ph, command );
}
//launch media player
void launch_player() {

	char command[156]="exec ";
	strcat(command, ppath);
	xchat_command( ph, command );
}

static gboolean tray_destroyed (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
        tray_init_gui();
	return TRUE;
}

//restore function
void tray_restore() {
	status=1;
	xchat_set_context(ph, flash_ctx);
	xchat_command( ph, "gui focus" );
	xchat_command( ph, "gui show" );
}
//minimize function
void tray_minimize() {
	status=0;
	xchat_command( ph, "gui hide" );
}

//exit from the tray function
void tray_exit() {

	gtk_signal_disconnect(tray_icon,s2);
	gtk_signal_disconnect(eventbox,s1);
	g_hash_table_destroy(servers_names);
	gtk_widget_destroy (GTK_WIDGET (tray_icon));
	onExit=0;
	xchat_command( ph, "timer 1 killall" );
}

void select_event_tab() {

	xchat_set_context(ph, flash_ctx);
	xchat_command( ph, "gui focus" );

}

//catch mouse clicks on icon
static gboolean tray_clicked (GtkWidget *event_box, GdkEventButton *event, gpointer data)
{
	//mouse wheel or middle click + left double click
	if ( (event->button == 1 && event->type == GDK_2BUTTON_PRESS) ||event->button == 2) {
        	if (status == 0) tray_restore();
	        else tray_minimize();

	}

	//single click gives focus only
	if (event->button == 1) select_event_tab();

	//mouse right click
	if (event->button == 3) {
		return tray_menu (event_box, event, data);
	}

	return FALSE;
}


//destroy the menu down
static void
tray_menu_finished (GtkObject *menu, gpointer user_data)
{
	gtk_widget_destroy (GTK_WIDGET (menu));
}


//create men linked to the tray icon
static gboolean
tray_menu (GtkWidget *widget, GdkEventButton *event, gpointer data)
{
	GtkWidget *menuImage;
	static GdkPixbuf *buffer1 = NULL;
	static GdkPixbuf *buffer2;
	static GdkPixbuf *buffer3;
	static GdkPixbuf *buffer4;
	static GdkPixbuf *buffer5;
	static GdkPixbuf *buffer6;
	static GdkPixbuf *buffer7;
	static GdkPixbuf *buffer8;
	// n9 is needed outside too!

	if (!buffer1)
	{
		/* only decode the images once */
		buffer1 = gdk_pixbuf_new_from_inline (-1, xchatsettings, FALSE, NULL);
		buffer2 = gdk_pixbuf_new_from_inline (-1, xchatbrowser, FALSE, NULL);
		buffer3 = gdk_pixbuf_new_from_inline (-1, xchatplayer, FALSE, NULL);
		buffer4 = gdk_pixbuf_new_from_inline (-1, xchatemail, FALSE, NULL);
		buffer5 = gdk_pixbuf_new_from_inline (-1, xchatmaxxpm, FALSE, NULL);
		buffer6 = gdk_pixbuf_new_from_inline (-1, xchatminxpm, FALSE, NULL);
		buffer7 = gdk_pixbuf_new_from_inline (-1, xchatquitpng, FALSE, NULL);
		buffer8 = gdk_pixbuf_new_from_inline (-1, backawaypng, FALSE, NULL);
		buffer9 = gdk_pixbuf_new_from_inline (-1, goawaypng, FALSE, NULL);
	}

	status_menu = gtk_menu_new();

	//setting item
	item = gtk_image_menu_item_new_with_label ("SysTray Settings");
	menuImage = gtk_image_new_from_pixbuf (buffer1);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (set_tray),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//Browser item
	item = gtk_image_menu_item_new_with_label ("Web Browser");
	menuImage = gtk_image_new_from_pixbuf (buffer2);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (launch_browser),NULL);

	//multimedia player item
	item = gtk_image_menu_item_new_with_label ("Multimedia");
	menuImage = gtk_image_new_from_pixbuf (buffer3);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (launch_player),NULL);

	//email item
	item = gtk_image_menu_item_new_with_label ("Email");
	menuImage = gtk_image_new_from_pixbuf (buffer4);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (launch_email),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//Go Away item
	item = gtk_image_menu_item_new_with_label ("Go Away");
	menuImage = gtk_image_new_from_pixbuf (buffer9);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (select_away),NULL);

	//Back from way
	item = gtk_image_menu_item_new_with_label ("Come Back");
	menuImage = gtk_image_new_from_pixbuf (buffer8);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (back_away),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//restore item
	item = gtk_image_menu_item_new_with_label ("Restore");
	menuImage = gtk_image_new_from_pixbuf (buffer5);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (tray_restore),NULL);

	//minimize item
	item = gtk_image_menu_item_new_with_label ("Minimize");
	menuImage = gtk_image_new_from_pixbuf (buffer6);
 	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (tray_minimize),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//stop flashing item
	item = gtk_image_menu_item_new_with_label ("Stop Flashing");
	menuImage = gtk_image_new_from_pixbuf (pix_xchat);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (flash_stop),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//exit item
	item = gtk_image_menu_item_new_with_label ("Exit");
	menuImage = gtk_image_new_from_pixbuf (buffer7);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (tray_exit),NULL);

	//when the menu is popped-down, you need to destroy it
	g_signal_connect (G_OBJECT (status_menu), "selection-done",
			  G_CALLBACK (tray_menu_finished), NULL);

	//finalization
	gtk_widget_show_all (status_menu);
	gtk_menu_popup (GTK_MENU(status_menu), NULL, NULL,NULL, NULL,event->button, event->time);

	return TRUE;
}


// EVENTS HANDLING AND FLASHING


//set flashing icon
static gboolean flash_timeout(gpointer userdata)
{
	static int i = 0;

	i++;
	if (i == 2)
	{
		i = 0;
		if (global_away && on_away) gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), buffer9);
		else gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), pix_xchat);
	} else
	{
		gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), icontype);
	}

	return TRUE;
}

//make flash start
static void flash_start()
{
	if(flash_id == 0)
		flash_id = g_timeout_add(500, flash_timeout, NULL);
}

//stop flash
static void flash_stop()
{
	if(flash_id)
	{
		if (global_away && on_away) gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), buffer9);
		else gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), pix_xchat);
		g_source_remove(flash_id);
		flash_id = 0;
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Nothing Particular ", NULL);
	}
}

//on hilight
static int noti_hilight_cb(char *word[], void *userdata)
{
	if(xchat_get_context(ph) != focus_ctx)
	{
		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_blue;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Somebody asked for you ", NULL);
	}

	return XCHAT_EAT_NONE;
}

//find focus
static int noti_focus_cb(char *word[], void *userdata)
{
	focus_ctx = xchat_get_context(ph);

	if(focus_ctx == flash_ctx)
		flash_stop();

	return XCHAT_EAT_NONE;
}

//on query
static int query_cb(char *word[],  void *userdata)
{


       if ( xchat_get_context(ph) != focus_ctx)
	{
		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_blue;
		flash_start();
		gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon),"XChat2 - Somebody send you a message", NULL);
	}

        return XCHAT_EAT_NONE;
}

//on disconnection
static int disconnect_cb(char *word[], void *userdata)
{
       if ( xchat_get_context(ph) != focus_ctx)
	{
		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_disc;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Disconnected from server ", NULL);
	}

        return XCHAT_EAT_NONE;
}

//on kick/ban
static int kicked_cb(char *word[], void *userdata)
{
       if ( xchat_get_context(ph) != focus_ctx)
	{
		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_red;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - You have been kicked ", NULL);
	}

        return XCHAT_EAT_NONE;
}

//on kill
static int killed_cb(char *word[], void *userdata)
{


       if ( xchat_get_context(ph) != focus_ctx)
	{
		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_red;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - You have been killed ", NULL);
	}

        return XCHAT_EAT_NONE;
}

//on dcc char request
static int chatreq_cb(char *word[], void *userdata)
{
		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_dcc;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Somebody offering a dcc chat to you ", NULL);

        return XCHAT_EAT_NONE;
}

//on dcc send/ dcc event
static int dcc_cb(char *word[], void *userdata)
{

		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_dcc;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Somebody offering a dcc to you", NULL);

        return XCHAT_EAT_NONE;
}

//on invite
static int invited_cb(char *word[], void *userdata)
{

		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_inv;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Somebody invited you to a channel", NULL);

        return XCHAT_EAT_NONE;
}

// friend away from notify
static int notout_cb(char *word[], void *userdata)
{

		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_notout;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - A friend went away", NULL);

        return XCHAT_EAT_NONE;
}

//a new friend in notify
static int notin_cb(char *word[], void *userdata)
{

		flash_ctx = xchat_get_context(ph);
		icontype=pix_xchat_notin;
		flash_start();
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - A new friend online", NULL);

        return XCHAT_EAT_NONE;
}


//INIZIALIZATION OF PLUGIN AND ICON

// events handling
static void tray_init_xchat(void)
{
	//show warning if version is too old
	const char *str;
	int i;
 	if (xchat_get_prefs (ph, "away_size_max", &str, &i) == 0)
	version_warning();

	focus_ctx = xchat_get_context(ph);
	xchat_hook_print(ph, "Focus Tab", XCHAT_PRI_NORM, noti_focus_cb, 0);
	xchat_hook_print(ph, "Channel Action Hilight", XCHAT_PRI_NORM, noti_hilight_cb, 0);
	xchat_hook_print(ph, "Channel Msg Hilight", XCHAT_PRI_NORM, noti_hilight_cb, 0);
	xchat_hook_print(ph, "Private Message", XCHAT_PRI_NORM, query_cb, NULL);
	xchat_hook_print(ph, "Private Message to Dialog", XCHAT_PRI_NORM, query_cb, 0);
	xchat_hook_print(ph, "Disconnected", XCHAT_PRI_NORM, disconnect_cb, 0);
	xchat_hook_print(ph, "You kicked", XCHAT_PRI_NORM, kicked_cb, 0);
	xchat_hook_print(ph, "Killed", XCHAT_PRI_NORM, killed_cb, 0);
	xchat_hook_print(ph, "DCC CHAT Offer", XCHAT_PRI_NORM, chatreq_cb, 0);
	xchat_hook_print(ph, "DCC CHAT Reoffer", XCHAT_PRI_NORM, chatreq_cb, 0);
	xchat_hook_print(ph, "DCC SEND offer", XCHAT_PRI_NORM, dcc_cb, 0);
	xchat_hook_print(ph, "Invited", XCHAT_PRI_NORM, invited_cb, 0);
	xchat_hook_print(ph, "Notify Offline", XCHAT_PRI_NORM, notout_cb, 0);
	xchat_hook_print(ph, "Notify Online", XCHAT_PRI_NORM, notin_cb, 0);
	xchat_printf(ph, "SysTray Integration Plugin Version %s successfully loaded.",version);
	xchat_printf(ph, "Patrizio Bassi - hetfield@email.it - http://www.blight.tk");

}


// gui start and icon setting
void tray_init_gui (void)
{
	//set the pics
	pix_xchat = gdk_pixbuf_new_from_inline(-1, xchatpng, FALSE, 0);
	pix_xchat_red = gdk_pixbuf_new_from_inline(-1, xchatredpng, FALSE, 0);
	pix_xchat_blue = gdk_pixbuf_new_from_inline(-1, xchatbluepng, FALSE, 0);
	pix_xchat_dcc= gdk_pixbuf_new_from_inline(-1, xchatdccxpm, FALSE, 0);
	pix_xchat_disc= gdk_pixbuf_new_from_inline(-1, xchatdiscxpm, FALSE, 0);
	pix_xchat_inv= gdk_pixbuf_new_from_inline(-1, xchatinvxpm, FALSE, 0);
	pix_xchat_notin= gdk_pixbuf_new_from_inline(-1, xchatnotinxpm, FALSE, 0);
	pix_xchat_notout= gdk_pixbuf_new_from_inline(-1, xchatnotoutxpm, FALSE, 0);
	icontype=pix_xchat;

	//add icons and container
	tray_icon = egg_tray_icon_new ("xchat");
 	tray_icon_image = gtk_image_new_from_pixbuf (pix_xchat);
	eventbox = gtk_event_box_new ();
	gtk_widget_show (eventbox);
	gtk_container_add (GTK_CONTAINER (eventbox), tray_icon_image);
	gtk_container_add (GTK_CONTAINER (tray_icon), eventbox);
	s1=g_signal_connect (G_OBJECT (eventbox), "button_press_event",G_CALLBACK (tray_clicked), NULL );
	s2=g_signal_connect (G_OBJECT (tray_icon), "destroy",G_CALLBACK (tray_destroyed), NULL);

	//finalize
	gtk_widget_show_all (GTK_WIDGET (tray_icon));

	//tooltip
	tray_icon_tooltip = gtk_tooltips_new ();
	gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Nothing Particular ", NULL);
	gtk_tooltips_set_delay(tray_icon_tooltip,1000);
	//set apps variables, only on start
	if (on_start)	get_info();
	on_start=FALSE;
	servers_names = g_hash_table_new(NULL,NULL);
}

//start gui and plugin
static void tray_init(void)
{
	tray_init_xchat();
	tray_init_gui();
}

//unloading function
int xchat_plugin_deinit(xchat_plugin *plugin_handle)
{
	if (onExit==1) {
	gtk_signal_disconnect(tray_icon,s2);
	gtk_signal_disconnect(eventbox,s1);
	g_hash_table_destroy(servers_names);
	gtk_widget_destroy (GTK_WIDGET (tray_icon));
	xchat_print(ph, "SysTray integration Plugin unloaded\n");
	}
	return 1;
}

//bootstrap
int xchat_plugin_init(
				xchat_plugin *plugin_handle,
				char **plugin_name,
				char **plugin_desc,
				char **plugin_version,
				char *arg)
{
	ph = plugin_handle;

	*plugin_name = "SysTray";
	*plugin_desc = "SysTray Integration Plugin";
	*plugin_version = "2.3.1";
	version=*plugin_version;
	tray_init();

	return 1;
}
